<?php
/**
 * @copyright: Copyright © 2020 Firebear Studio. All rights reserved.
 * @author   : Firebear Studio <fbeardev@gmail.com>
 */

namespace Firebear\SapDbQueue\Plugin;

use Firebear\PlatformSap\Model\Customer\UpdatePublisher;
use Magento\Customer\Api\Data\CustomerInterface;
use Magento\Framework\MessageQueue\PublisherInterface;

/**
 * Class CustomerUpdateDbPlugin
 * @package Firebear\SapDbQueue\Plugin
 */
class CustomerUpdateDbPlugin
{
    const TOPIC_NAME = 'sap.customer.update.db';

    /**
     * @var PublisherInterface
     */
    private $publisher;

    /**
     * CustomerUpdateDbPlugin constructor.
     * @param PublisherInterface $publisher
     */
    public function __construct(
        PublisherInterface $publisher
    ) {
        $this->publisher = $publisher;
    }

    /**
     * @param UpdatePublisher $subject
     * @param \Closure $proceed
     * @param CustomerInterface $customer
     */
    public function aroundExecute(
        UpdatePublisher $subject,
        \Closure $proceed,
        CustomerInterface $customer
    ) {
        $this->publisher->publish(self::TOPIC_NAME, $customer);
    }
}
