<?php
/**
 * @copyright: Copyright © 2020 Firebear Studio. All rights reserved.
 * @author   : Firebear Studio <fbeardev@gmail.com>
 */

namespace Firebear\SapDbQueue\Plugin;

use Firebear\PlatformSap\Model\Order\UpdatePublisher;
use Magento\Sales\Api\Data\OrderInterface;
use Magento\Framework\MessageQueue\PublisherInterface;

/**
 * Class OrderUpdateDbPlugin
 * @package Firebear\SapDbQueue\Plugin
 */
class OrderUpdateDbPlugin
{
    const TOPIC_NAME = 'sap.order.update.db';

    /**
     * @var PublisherInterface
     */
    private $publisher;

    /**
     * CustomerUpdateDbPlugin constructor.
     * @param PublisherInterface $publisher
     */
    public function __construct(
        PublisherInterface $publisher
    ) {
        $this->publisher = $publisher;
    }

    /**
     * @param UpdatePublisher $subject
     * @param \Closure $proceed
     * @param string $orderId
     */
    public function aroundExecute(
        UpdatePublisher $subject,
        \Closure $proceed,
        string $orderId
    ) {
        $this->publisher->publish(self::TOPIC_NAME, $orderId);
    }
}
